config/routes.rb
Rails.application.routes.draw do

  
  devise_for :users
  get 'overview' => 'categories#index'
  get 'manage' => 'pages#manage'
  
  resources :categories do
    resources :transactions
  end
  
  resources :incomes
  resources :transactions 

  root 'pages#index'

  

end

app/models/category.rb
class Category < ActiveRecord::Base
  has_many :transactions
  has_many :incomes
  
  belongs_to :user
  validates :name, presence: true




  

  # Mainly to add the functionality of sum
  # fucntions.
  #
  def as_json(options={})
    # .reject { |k, v| v.nil? }
    result = super(options)
    if options.has_key?(:total)
      result["total"] = sum_t.to_f
    end
    
    result
  end

  # Returns a Google Array data table without the headers
  # the data is category name and the total amount 
  # spent in that category
  #
  def self.as_array_table
    result = []
    result.push(['Category', 'Amount'])
    data = []
    
    # find_each limits to 1000
    Category.find_each do |x|
      data.push( x.as_json(only: [:name, :amount], total: true).values )
    end
    result.concat(data)
  end

  # Returns the total amount for this category
  #
  def sum_i
    incomes.each.inject(BigDecimal.new(0)) do |total, val|
      total += val.amount
    end
  end


  # Returns the total spent for the category
  # 
  def sum_t
    transactions.each.inject(BigDecimal.new(0)) do |total, val|
      total += val.amount
    end
  end
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :set_category, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!
  
  # GET /categories
  # GET /categories.json
  def index
    @title = "Spending by category"
    @categories = current_user.categories.all
    @transactions = current_user.categories.first.transactions

  end

  # GET /categories/1
  # GET /categories/1.json
  def show
  end

  # GET /categories/new
  def new
    @title = "Add a new Category"
    @category = current_user.category.new
  end

  # GET /categories/1/edit
  def edit
    @title = "end"
  end

  # POST /categories
  # POST /categories.json
  def create
    @category = current_user.new(category_params)
    
    respond_to do |format|
      if @category.save
        format.html { redirect_to @category, notice: 'Category was successfully created.' }
        format.json { render :show, status: :created, location: @category }
      else
        format.html { render :new }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /categories/1
  # PATCH/PUT /categories/1.json
  def update
    respond_to do |format|
      if @category.update(category_params)
        format.html { redirect_to @category, notice: 'Category was successfully updated.' }
        format.json { render :show, status: :ok, location: @category }
      else
        format.html { render :edit }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /categories/1
  # DELETE /categories/1.json
  def destroy
    @category.destroy
    respond_to do |format|
      format.html { redirect_to categories_url, notice: 'Category was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_category
      @category = Category.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def category_params
      params.require(:category).permit(:name)
    end
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/views/categories/_form.html.erb
<div class="col-xs-12 col-sm-4 col-md-offset-4">
  <%= form_for(@category, :html => {:class => "form"}) do |f| %>

  <% if @category.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@category.errors.count, "error") %> prohibited this category from being saved:</h2>

      <ul>
      <% @category.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>
  
    <div class="form-group">
      <%= f.label :name %>
      <%= f.text_field :name, :class => "form-control", :placeholder => "Utilities"%>
    </div>

    <%= f.submit "Save", :class => "btn btn-default" %>
    
  <% end %>

</div>

app/views/categories/edit.html.erb
<%= render 'form' %>
<div class="row">
    <%= link_to "Delete", category_path(@category), method: :delete, data: { confirm: 'Are you sure?' }, :class => "btn btn-danger pull-right" %>        
</div>

app/views/categories/index.html.erb
<div class="row">

  <div class="row ">
    <h1 id="spent-header" class="text-right">Spent: <%= number_to_currency(Transaction.sum(:amount), :precision => 2) %></br>
      <small>Total buget: <%= number_to_currency(Income.sum(:amount), :precision => 2)  %></small></h1>
  </div>
  <%= pie_chart Category.includes(:transactions).group('categories.name').sum(:amount) %>

</div>


<div class="row">
  <div class="col-xs-6"><%= collection_select nil, :category_id, @categories, :id, :name, {}, {:class => "form-control col-sm-4"} %></div>
  <div class="col-xs-6"><%= link_to 'New Category', new_category_path, :class => "btn btn-default pull-right" %></div>
</div>

<div class="table-responsive">
  <table class="table table-hover">
    <caption>Transactions</caption>
    <thead>
    </thead>
    <tbody id="trans">
      <% @transactions.each do |trans| %>
        <tr>
          <td><%= link_to trans.name, category_transactions_path(trans.category) %></td>
          <td><em><small><%= number_to_currency(trans.amount, :precision => 2)  %></small></em></td>
        </tr>
      <% end %>
    </tbody>
  </table>
</div>  



<script type="text/javascript">
 /*  google.load("visualization", "1", {packages:["corechart"]}); */
 $(function() {
     $("#_category_id").on('change', function () {
         var url = $(this).val();
         var $tbody = $("#trans");
         /* call the url to get all the transactions for selected category */
         $.ajax({
             url: 'categories/' + url + '/transactions.json',
             data: {
                 format: 'json'
             },
             dataType:'json',
             success: function(data) {
                 $tbody.html("");
                 $.each(data, function(i, item) {
                     var $tr = $('<tr>').append(
                         $('<td>').html("<a href=" + item.url.replace(".json", "") + ">" + item.name + "</a>"),
                         $('<td>').html("<em><small>" + item.amount + "</em></small>")
                     ).appendTo($tbody);
                     
                 });
             },
             error: function(){
                 $tbody.html("");
                 $("<tr>").append($("<td>").text("Error loading")).appendTo($tbody);
                 
             }
         });
     });
     
     
     /* google.setOnLoadCallback(drawChart); */
     /* function drawChart() {
        var data = google.visualization.arrayToDataTable(
        <%# raw Category.as_array_table %>
        );
        
        var options = {
        height: 350,
        width: 320,
        title: 'Spending by Category',
        pieHole: 0.4,
        legend: 'none', 
        };

        var chart = new google.visualization.PieChart(document.getElementById('donutchart'));
        chart.draw(data, options);
        }
      */
 });

 

</script>

app/views/categories/new.html.erb
<%= render 'form' %>

app/views/categories/show.html.erb
<p>
  <strong>Name:</strong>
  <%= @category.name %>
</p>